indexing

   title:       "Float point formatter";
   cluster:     "format/science [format/science]";
   project:     "The Universal Simple Formatting Library (USFL)";
   copyright:   "SIG Computer, 1995";
   author:      "Igor Nesterof (nest@eiffel.ru)";
   original:    08,Sep,1995;
   version:     1.0;
   done_at:     "SIG Computer (info@eiffel.ru)";
   extrnl_name: "floatfmt.e"

class FLOAT_POINT_FORMATTER

inherit
   FIXED_POINT_FORMATTER
      redefine
         make, output
   end

creation
   make

feature {ABSTRACT_FORMATTER}

   -- number image saves as
   -- number := fsign*(int_part+fract_part)*10^exponent
   exponent : INTEGER


feature

------------------------------------------------------------make
   -- save new part - exponent, other save as fixed point :-)
   make, frozen float_point_make(f:REAL_REF) is
   require else
      format_real : f /= Void
   local
      fa, mantissa, fsgn : REAL
   do
      fa := abs(f.item)
      fsgn := real_sign(f.item)
      if f.item /= 0 then
         exponent := floor(log10(fa))
      else
         exponent := 0
      end
      mantissa := fa / ten_power(exponent)
      fixed_point_make(fsgn*mantissa)
   end
------------------------------------------------------------output
   output, frozen float_output : STRING is
   local
      e_f : INTEGER_FORMATTER
   do
      Result := make_fract_part
      -- make exponent part
      !!e_f.make(exponent)
      e_f.set_precision(2)
      e_f.set_sign('+')
      x_extend(Result,'e')
      x_append(Result,e_f.output)
      -- make integer part and finish alignment
      inspect alignment
      when align_left then
         i_f.set_width(1)
         Result.prepend(i_f.output)
         Result := right_pad(Result,' ',width)
      when align_right then
         i_f.set_width(width-Result.count)
         i_f.set_align_right
         Result.prepend(i_f.output)
      when align_center then
         i_f.set_width(1)
         Result.prepend(i_f.output)
         Result := center_pad(Result,' ',width)
      end
   end

end -- class FLOAT_POINT_FORMATTER
